## ginkgocadx 2.4.1.1

=== src/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

PROJECT(BUILD_ALL)

SET( USE_PATCHED_LIBS        FALSE CACHE BOOL "Use patched libraries")
SET( BUILD_VISUALIZATION_EXT TRUE CACHE BOOL "Build Visualization extention")
SET( BUILD_OPHTALMOLOGY_EXT  FALSE CACHE BOOL "Build Ophtalmology extension")
SET( BUILD_DERMATHOLOGY_EXT  FALSE CACHE BOOL "Build Dermathology extension")
SET( BUILD_VIDEO_EXT         FALSE CACHE BOOL "Build Video extension")
SET( BUILD_FOO_EXT           FALSE CACHE BOOL "Build Foo extension")

SET( USE_CUSTOM_WX           FALSE CACHE BOOL "Build with custom WX library")
SET( USE_CUSTOM_VTK          FALSE CACHE BOOL "Build with custom VTK library")
SET( USE_CUSTOM_ITK          FALSE CACHE BOOL "Build with custom ITK library")
SET( USE_CUSTOM_DCMTK        FALSE CACHE BOOL "Build with custom DCMTK library")

SET( CUSTOM_PACKAGE          FALSE CACHE BOOL "Custom package")

SET( GINKGO_VERSION "2.4.1.1" CACHE STRING "Ginkgo version")

SET( CMAKE_OSX_ARCHITECTURES "i386" CACHE STRING "MacOSX Architectures" FORCE)

IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)


#############################################################################################

SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/CMake)
INCLUDE(SysDefs)

#############################################################################################

IF(LINUX)
	FIND_PACKAGE(GTK2 REQUIRED)
ENDIF()

IF(USE_PATCHED_LIBS) 
	MESSAGE("Using patched libs")
ENDIF()

IF(NOT USE_CUSTOM_WX)
	MESSAGE("Using system wxWidgets")
	FIND_PACKAGE(wxWidgets 2.8.11 COMPONENTS core base gl net xml aui adv richtext xrc REQUIRED)
ELSE()
	MESSAGE("Using custom wxWidgets")
	SET_CUSTOM_wxWidgets_PACKAGE()
ENDIF()

IF(NOT USE_CUSTOM_VTK)
	MESSAGE("Using system VTK")
	FIND_PACKAGE(VTK 5.6.1 REQUIRED)
ELSE()
	MESSAGE("Using custom VTK")
	SET_CUSTOM_VTK_PACKAGE()
ENDIF()

IF(NOT USE_CUSTOM_ITK)
	MESSAGE("Using system ITK")
	FIND_PACKAGE(ITK REQUIRED)
ELSE()
	MESSAGE("Using custom ITK")
	SET_CUSTOM_ITK_PACKAGE()
ENDIF()

IF(NOT USE_CUSTOM_DCMTK)
	MESSAGE("Using system DCMTK")
	FIND_PACKAGE(DCMTK 3.6.0 EXACT REQUIRED)
ELSE()
	MESSAGE("Using custom DCMTK")
	SET_CUSTOM_DCMTK_PACKAGE()
ENDIF()

#############################################################################################

IF(MACOS)
	SET(GINKGO_PROJECT "Ginkgo CADx" CACHE PARENT_SCOPE "")
ELSEIF(LINUX AND CUSTOM_PACKAGE)
	SET(GINKGO_PROJECT "ginkgo-${ARCH}" CACHE PARENT_SCOPE "")
ELSE()
	SET(GINKGO_PROJECT "ginkgo" CACHE PARENT_SCOPE "")
ENDIF()

SET(GINKGO_PLUGINS "" CACHE PARENT_SCOPE "")

SUBDIRS( cadxcore ginkgo  )

IF (BUILD_OPHTALMOLOGY_EXT OR BUILD_DERMATHOLOGY_EXT OR BUILD_VIDEO_EXT)
	INCLUDE(PrvExtDeps)
ENDIF()

IF(BUILD_FOO_EXT)
	SUBDIRS(fooextension)
ENDIF()

IF(BUILD_OPHTALMOLOGY_EXT)
	SUBDIRS(oftalmologia)
ENDIF()

IF(BUILD_DERMATHOLOGY_EXT)
	SUBDIRS(dermatologia)
ENDIF()

IF(BUILD_VIDEO_EXT)
	SUBDIRS(video)
ENDIF()

IF(BUILD_VISUALIZATION_EXT)
	SUBDIRS(visualizator)
ENDIF()

ADD_CUSTOM_TARGET(${PROJECT_NAME} echo)

MESSAGE("GINKGO_PROJECT = ${GINKGO_PROJECT}")

ADD_DEPENDENCIES(${PROJECT_NAME} "${GINKGO_PROJECT}")

IF(BUILD_FOO_EXT)
	ADD_DEPENDENCIES(${PROJECT_NAME} fooextension)
	LIST(APPEND GINKGO_PLUGINS "fooextension")
ENDIF()

IF(BUILD_VISUALIZATION_EXT)
	ADD_DEPENDENCIES(${PROJECT_NAME} visualizator)
	LIST(APPEND GINKGO_PLUGINS "visualizator")
ENDIF()

IF(BUILD_OPHTALMOLOGY_EXT)
	ADD_DEPENDENCIES(${PROJECT_NAME} oftalmologia)
	LIST(APPEND GINKGO_PLUGINS "oftalmologia")
ENDIF()

IF(BUILD_DERMATHOLOGY_EXT)
	ADD_DEPENDENCIES(${PROJECT_NAME} dermatologia)
	LIST(APPEND GINKGO_PLUGINS "dermatologia")
ENDIF()

IF(BUILD_VIDEO_EXT)
	ADD_DEPENDENCIES(${PROJECT_NAME} video)
	LIST(APPEND GINKGO_PLUGINS "video")
ENDIF()

IF(CUSTOM_PACKAGE)

SET( DEST "${CMAKE_CURRENT_BINARY_DIR}/dist" )
PACKAGE_RULES( "${PROJECT_NAME}" "${ARCH}" "${DEST}" )
ENDIF()

=== src/cadxcore/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

PROJECT(CADxCore)

################ SOURCES ################

AUX_SOURCE_DIRECTORY(api SRCS)
AUX_SOURCE_DIRECTORY(api/controllers SRCS)
AUX_SOURCE_DIRECTORY(api/helpers SRCS)
AUX_SOURCE_DIRECTORY(api/math SRCS)
AUX_SOURCE_DIRECTORY(api/observers SRCS)

AUX_SOURCE_DIRECTORY(main SRCS)
AUX_SOURCE_DIRECTORY(main/controllers SRCS)
AUX_SOURCE_DIRECTORY(main/filtering SRCS)
AUX_SOURCE_DIRECTORY(main/gui SRCS)
AUX_SOURCE_DIRECTORY(main/gui/adquisition SRCS)
AUX_SOURCE_DIRECTORY(main/gui/callibration SRCS)
AUX_SOURCE_DIRECTORY(main/gui/configuration SRCS)
AUX_SOURCE_DIRECTORY(main/gui/dicomeditor SRCS)
AUX_SOURCE_DIRECTORY(main/gui/export SRCS)
AUX_SOURCE_DIRECTORY(main/gui/history SRCS)
AUX_SOURCE_DIRECTORY(main/gui/hl7controlwindow SRCS)
AUX_SOURCE_DIRECTORY(main/gui/import SRCS)
AUX_SOURCE_DIRECTORY(main/gui/license SRCS)
AUX_SOURCE_DIRECTORY(main/gui/logcontrolwindow SRCS)
AUX_SOURCE_DIRECTORY(main/gui/login SRCS)
AUX_SOURCE_DIRECTORY(main/gui/mainwindow SRCS)
AUX_SOURCE_DIRECTORY(main/gui/open SRCS)
AUX_SOURCE_DIRECTORY(main/gui/pacsupload SRCS)
AUX_SOURCE_DIRECTORY(main/gui/paneltags SRCS)
AUX_SOURCE_DIRECTORY(main/gui/print SRCS)
AUX_SOURCE_DIRECTORY(main/gui/progress SRCS)
AUX_SOURCE_DIRECTORY(main/gui/tabtoolbar SRCS)
AUX_SOURCE_DIRECTORY(main/managers SRCS)
AUX_SOURCE_DIRECTORY(main/tools SRCS)
AUX_SOURCE_DIRECTORY(main/controllers/dcmtk SRCS)
AUX_SOURCE_DIRECTORY(main/controllers/dcmtk/libi2d SRCS)
AUX_SOURCE_DIRECTORY(main/controllers/dcmtk/ofstd SRCS)
AUX_SOURCE_DIRECTORY(main/controllers/dcmtk/tls SRCS)
AUX_SOURCE_DIRECTORY(main/controllers/dcmtk/tls/win-only SRCS)
AUX_SOURCE_DIRECTORY(main/controllers/log4cplus SRCS)
AUX_SOURCE_DIRECTORY(main/controllers/streaming SRCS)

AUX_SOURCE_DIRECTORY(commands SRCS)

AUX_SOURCE_DIRECTORY(net SRCS)

AUX_SOURCE_DIRECTORY(resources SRCS)

AUX_SOURCE_DIRECTORY(sqlite SRCS)

AUX_SOURCE_DIRECTORY(endpoint SRCS)

AUX_SOURCE_DIRECTORY(vtk SRCS)
AUX_SOURCE_DIRECTORY(vtk/command SRCS)
AUX_SOURCE_DIRECTORY(vtk/interactor SRCS)
AUX_SOURCE_DIRECTORY(vtk/widgets SRCS)

AUX_SOURCE_DIRECTORY(widgets SRCS)
AUX_SOURCE_DIRECTORY(widgets/gui SRCS)
AUX_SOURCE_DIRECTORY(widgets/observers SRCS)

AUX_SOURCE_DIRECTORY(wx SRCS)
AUX_SOURCE_DIRECTORY(wx/ginkgostyle SRCS)
AUX_SOURCE_DIRECTORY(wx/gnkinforme SRCS)
AUX_SOURCE_DIRECTORY(wx/iconoimagenctrl SRCS)
AUX_SOURCE_DIRECTORY(wx/maskedtextctrl SRCS)
AUX_SOURCE_DIRECTORY(wx/propgrid SRCS)
AUX_SOURCE_DIRECTORY(wx/propiedades SRCS)
AUX_SOURCE_DIRECTORY(wx/thumbnailctrl SRCS)
AUX_SOURCE_DIRECTORY(wx/timectrl SRCS)
AUX_SOURCE_DIRECTORY(wx/treelistctrl SRCS)
AUX_SOURCE_DIRECTORY(wx/VTK SRCS)
AUX_SOURCE_DIRECTORY(wx/wizardginkgo SRCS)
AUX_SOURCE_DIRECTORY(wx/wxsqlite3 SRCS)

AUX_SOURCE_DIRECTORY(VTKInria3D SRCS)
AUX_SOURCE_DIRECTORY(VTKInria3D/vtkVISUManagement SRCS)
AUX_SOURCE_DIRECTORY(VTKInria3D/wxVTK SRCS)

AUX_SOURCE_DIRECTORY(resources SRCS)

IF (LINUX)
	AUX_SOURCE_DIRECTORY(xmlrpc SRCS)
ENDIF()

IF (LINUX OR MACOS)
	LIST(REMOVE_ITEM SRCS endpoint/interfaces.cpp)
	LIST(REMOVE_ITEM SRCS endpoint/sockatmark.cpp)
ELSEIF(WINDOWS)
	SET(SRCS stdafx.cpp ${SRCS})
ENDIF()

################ DEFINITIONS ################

ADD_CORE_DEFINITIONS()

################ INCLUDE DIRECTORIES ################

SET(${PROJECT_NAME}_INCLUDE_DIR
	${CMAKE_CURRENT_SOURCE_DIR}
	${CMAKE_CURRENT_SOURCE_DIR}/vtk
	${CMAKE_CURRENT_SOURCE_DIR}/itk
	${CMAKE_CURRENT_SOURCE_DIR}/wx
	${CMAKE_CURRENT_SOURCE_DIR}/wx/VTK
	${CMAKE_CURRENT_SOURCE_DIR}/VTKInria3D
	${CMAKE_CURRENT_SOURCE_DIR}/VTKInria3D/wxVTK
	${CMAKE_CURRENT_SOURCE_DIR}/VTKInria3D/vtkRenderingAddons
	CACHE INTERNAL ""
)

INCLUDE_DIRECTORIES(${PROJECT_NAME} ${${PROJECT_NAME}_INCLUDE_DIR} )

################ TARGET ################

ADD_LIBRARY(${PROJECT_NAME} SHARED ${SRCS} )
#ADD_EXECUTABLE(${PROJECT_NAME} WIN32 MACOSX_BUNDLE ${SRCS})
SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES
	VERSION "${GINKGO_VERSION}" SOVERSION "${GINKGO_VERSION}"
	LINK_INTERFACE_LIBRARIES ""
	INSTALL_RPATH_USE_LINK_PATH TRUE )
INSTALL(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION share/ginkgocadx/bin)
INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/lang/es/ginkgocadxcore.mo DESTINATION share/ginkgocadx/bin/lang/es)
INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/lang/es/ginkgocadxcore.mo DESTINATION share/ginkgocadx/bin/lang/ja)

################ LIBS ################

IF(USE_CUSTOM_WX)
	ADD_DEFINITIONS(${wxWidgets_defines})
	INCLUDE_DIRECTORIES(${wxWidgets_INCLUDE_DIR})
	LINK_DIRECTORIES(${wxWidgets_DIR})
ELSE()
	INCLUDE(${wxWidgets_USE_FILE})
	#MESSAGE("WXLIBS = ${wxWidgets_LIBRARIES} ")
ENDIF()

TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${wxWidgets_LIBRARIES})

IF (USE_CUSTOM_VTK)
	ADD_DEFINITIONS(${VTK_defines})
	INCLUDE_DIRECTORIES(${VTK_INCLUDE_DIR})
	LINK_DIRECTORIES(${VTK_DIR})
ELSE()
	INCLUDE(${VTK_USE_FILE})
	SET(VTK_LIBRARIES vtkCommon vtkGraphics vtkFiltering vtkHybrid vtkIO vtkRendering vtkImaging
	vtkGenericFiltering vtkWidgets vtkftgl vtkVolumeRendering vtkexoIIc vtkDICOMParser CACHE INTERNAL "")
	#MESSAGE("VTKLIBS = ${VTK_LIBRARIES}")
ENDIF()

TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${VTK_LIBRARIES})

IF(USE_CUSTOM_ITK)
	ADD_DEFINITIONS(${ITK_defines})
	INCLUDE_DIRECTORIES(${ITK_INCLUDE_DIR})
	LINK_DIRECTORIES(${ITK_DIR})
ELSE()
	INCLUDE(${ITK_USE_FILE})
	#MESSAGE("ITKLIBS = ${ITK_LIBRARIES}")
ENDIF()

TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${ITK_LIBRARIES})

IF(USE_CUSTOM_DCMTK)
	ADD_DEFINITIONS(${DCMTK_defines})
	INCLUDE_DIRECTORIES(${DCMTK_INCLUDE_DIR})
	LINK_DIRECTORIES(${DCMTK_DIR})
ELSE()
	ADD_DEFINITIONS(-DHAVE_CONFIG_H)
	INCLUDE_DIRECTORIES(${DCMTK_INCLUDE_DIRS})
	#MESSAGE("DCMTKLIBS = ${DCMTK_LIBRARIES}")
	#MESSAGE("DCMTKINC = ${DCMTK_INCLUDE_DIRS}")
	TARGET_LINK_LIBRARIES(${PROJECT_NAME} dcmdsig oflog /lib/libwrap.so.0)
ENDIF()

TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${DCMTK_LIBRARIES})

ADD_DEFINITIONS(${Cairo_defines})
INCLUDE_DIRECTORIES(${Cairo_INCLUDE_DIR})
LINK_DIRECTORIES(${Cairo_LIB})
TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${Cairo_LIBRARIES})

ADD_DEFINITIONS(${Pixman_defines})
INCLUDE_DIRECTORIES(${Pixman_INCLUDE_DIR})
LINK_DIRECTORIES(${Pixman_LIB})
TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${Pixman_LIBRARIES})

IF (MACOS)
	ADD_DEFINITIONS(${XmlRpc++_defines})
	INCLUDE_DIRECTORIES(${XmlRpc++_INCLUDE_DIR})
	LINK_DIRECTORIES(${XmlRpc++_DIR})
	TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${XmlRpc++_LIBRARIES})
ENDIF()

IF(LINUX)	
	INCLUDE_DIRECTORIES(${GTK2_INCLUDE_DIRS})
	#MESSAGE("GTKINC: ${GTK2_INCLUDE_DIRS}")
	#MESSAGE("GTKLIBS: ${GTK2_LIBRARIES}")
	TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${GTK2_LIBRARIES})
ENDIF()

IF (LINUX)
	TARGET_LINK_LIBRARIES(${PROJECT_NAME} ssl GL crypto xml2)
ENDIF()

IF(MACOS)
	FIND_LIBRARY( CARBON_LIB Carbon )
	FIND_LIBRARY( OPENGL_LIB OpenGL )
	
	MARK_AS_ADVANCED( CARBON_LIB OPENGL_LIB )

	SET(LIBS ${CARBON_LIB} ${OPENGL_LIB} )
	LIST( APPEND LIBS ssl crypto xml2 z )

	TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${LIBS})

	SET_TARGET_PROPERTIES( PROPERTIES LINK_FLAGS "-Wl ${XCODE_LINK_FLAGS}" )
	
ENDIF()

MESSAGE("OS=[${OS}], Arch=[${ARCH}], Target=[${CMAKE_BUILD_TYPE}], Project=[${PROJECT_NAME}]")

=== src/fooextension/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

PROJECT(fooextension)

################ SOURCES ################

SET(SRCS fooextension.cpp)
AUX_SOURCE_DIRECTORY(fooextension/commands SRCS)
AUX_SOURCE_DIRECTORY(fooextension/controllers SRCS)
AUX_SOURCE_DIRECTORY(fooextension/gui SRCS)
AUX_SOURCE_DIRECTORY(fooextension/gui/importation SRCS)
AUX_SOURCE_DIRECTORY(fooextension/studies SRCS)
AUX_SOURCE_DIRECTORY(fooextension/views SRCS)
AUX_SOURCE_DIRECTORY(fooextension/wxvtk SRCS)

################ DEFINITIONS ################

ADD_EXTENSION_DEFINITIONS()

################ INCLUDE DIRECTORIES ################

SET(${PROJECT_NAME}_INCLUDE_DIR
	${CMAKE_CURRENT_SOURCE_DIR}
	CACHE INTERNAL ""
)

INCLUDE_DIRECTORIES(${CADxCore_INCLUDE_DIR})

INCLUDE_DIRECTORIES(${${PROJECT_NAME}_INCLUDE_DIR})

################ TARGET ################

IF(LINUX AND NOT CUSTOM_PACKAGE)
	SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
	SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 
	SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/share/ginkgocadx/bin")
	SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
	LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/share/ginkgocadx/bin" isSystemDir)
	IF("${isSystemDir}" STREQUAL "-1")
		SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/share/ginkgocadx/bin")
	ENDIF()
ENDIF()

ADD_LIBRARY(${PROJECT_NAME} SHARED ${SRCS} )
#ADD_EXECUTABLE(${PROJECT_NAME} WIN32 MACOSX_BUNDLE ${SRCS})
SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES
	VERSION "${GINKGO_VERSION}" SOVERSION "${GINKGO_VERSION}"
	LINK_INTERFACE_LIBRARIES ""
	INSTALL_RPATH_USE_LINK_PATH TRUE )
INSTALL(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION share/ginkgocadx/bin/Plugins)

################ LIBS ################

TARGET_LINK_LIBRARIES(${PROJECT_NAME} CADxCore)

IF(USE_CUSTOM_WX)
	ADD_DEFINITIONS(${wxWidgets_defines})
	INCLUDE_DIRECTORIES(${wxWidgets_INCLUDE_DIR})
	LINK_DIRECTORIES(${wxWidgets_DIR})
ELSE()
	INCLUDE(${wxWidgets_USE_FILE})
	#MESSAGE("WXLIBS = ${wxWidgets_LIBRARIES} ")
ENDIF()

TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${wxWidgets_LIBRARIES})

IF (USE_CUSTOM_VTK)
	ADD_DEFINITIONS(${VTK_defines})
	INCLUDE_DIRECTORIES(${VTK_INCLUDE_DIR})
	LINK_DIRECTORIES(${VTK_DIR})
ELSE()
	INCLUDE(${VTK_USE_FILE})
	SET(VTK_LIBRARIES vtkCommon vtkGraphics vtkFiltering vtkHybrid vtkIO vtkRendering vtkImaging
	vtkGenericFiltering vtkWidgets vtkftgl vtkVolumeRendering vtkexoIIc vtkDICOMParser CACHE INTERNAL "")
	#MESSAGE("VTKLIBS = ${VTK_LIBRARIES}")
ENDIF()

TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${VTK_LIBRARIES})

IF(USE_CUSTOM_ITK)
	ADD_DEFINITIONS(${ITK_defines})
	INCLUDE_DIRECTORIES(${ITK_INCLUDE_DIR})
	LINK_DIRECTORIES(${ITK_DIR})
ELSE()
	INCLUDE(${ITK_USE_FILE})
	#MESSAGE("ITKLIBS = ${ITK_LIBRARIES}")
ENDIF()

TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${ITK_LIBRARIES})

ADD_DEFINITIONS(${Cairo_defines})
INCLUDE_DIRECTORIES(${Cairo_INCLUDE_DIR})
LINK_DIRECTORIES(${Cairo_LIB})
TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${Cairo_LIBRARIES})

ADD_DEFINITIONS(${Pixman_defines})
INCLUDE_DIRECTORIES(${Pixman_INCLUDE_DIR})
LINK_DIRECTORIES(${Pixman_LIB})
TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${Pixman_LIBRARIES})

IF (LINUX)
	TARGET_LINK_LIBRARIES(${PROJECT_NAME} GL xml2)
ENDIF()

IF(MACOS)
	FIND_LIBRARY( CARBON_LIB Carbon )
	FIND_LIBRARY( OPENGL_LIB OpenGL )
	
	MARK_AS_ADVANCED( CARBON_LIB OPENGL_LIB )

	SET(LIBS ${CARBON_LIB} ${OPENGL_LIB} )
	LIST( APPEND LIBS xml2 z )

	TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${LIBS})

	SET_TARGET_PROPERTIES( PROPERTIES LINK_FLAGS "-Wl ${XCODE_LINK_FLAGS}" )
	
ENDIF()

MESSAGE("OS=[${OS}], Arch=[${ARCH}], Target=[${CMAKE_BUILD_TYPE}], Project=[${PROJECT_NAME}]")

=== src/ginkgo/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

PROJECT(${GINKGO_PROJECT})

SET(SRCS main.cpp)

ADD_GINKGO_DEFINITIONS()

INCLUDE_DIRECTORIES(${CADxCore_INCLUDE_DIR})

IF(LINUX AND NOT CUSTOM_PACKAGE)
	SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
	SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 
	SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/share/ginkgocadx/bin")
	SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
	LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/share/ginkgocadx/bin" isSystemDir)
	IF("${isSystemDir}" STREQUAL "-1")
		SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/share/ginkgocadx/bin")
	ENDIF()
ENDIF()

ADD_EXECUTABLE(${PROJECT_NAME} WIN32 MACOSX_BUNDLE ${SRCS})
TARGET_LINK_LIBRARIES(${PROJECT_NAME} CADxCore)
SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES
	LINK_INTERFACE_LIBRARIES ""
	CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/share/ginkgocadx/bin")

INSTALL(TARGETS ${PROJECT_NAME} DESTINATION share/ginkgocadx/bin)

IF(USE_CUSTOM_WX)
        ADD_DEFINITIONS(${wxWidgets_defines})
        INCLUDE_DIRECTORIES(${wxWidgets_INCLUDE_DIR})
        LINK_DIRECTORIES(${wxWidgets_DIR})
ELSE()
        INCLUDE(${wxWidgets_USE_FILE})
	#MESSAGE("SYSTEM_WX: VL = ${VTK_DIR}")
        LINK_DIRECTORIES(${wxWidgets_DIR})
ENDIF()

IF (USE_CUSTOM_VTK)
	LINK_DIRECTORIES(${VTK_DIR})
ELSE()
	#MESSAGE("SYSTEM_VTK: VL = ${VTK_DIR}")
	LINK_DIRECTORIES(${VTK_LIBRARY_DIRS})
ENDIF()

IF(USE_CUSTOM_ITK)
	LINK_DIRECTORIES(${ITK_DIR})
ELSE()
	#MESSAGE("SYSTEM_ITK: IL = ${ITK_DIR}")
	LINK_DIRECTORIES(${ITK_DIR})
ENDIF()

IF(USE_CUSTOM_ITK)
	
ELSE()
	#MESSAGE("SYSTEM_DCMTK: DL = ${DCMTK_DIR}")
	LINK_DIRECTORIES(${DCMTK_LIBRARY_PATH})
ENDIF()

LINK_DIRECTORIES(${Cairo_DIR})
LINK_DIRECTORIES(${Pixman_DIR})
LINK_DIRECTORIES(${XmlRpc++_DIR})

IF(MACOS)
	SET(SRCS ${SRCS}
		${CMAKE_CURRENT_SOURCE_DIR}/ginkgo.icns
		${CMAKE_CURRENT_SOURCE_DIR}/dcmdoc.icns
	)
	SET_SOURCE_FILES_PROPERTIES(${CMAKE_CURRENT_SOURCE_DIR}/ginkgo.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
	SET_SOURCE_FILES_PROPERTIES(${CMAKE_CURRENT_SOURCE_DIR}/dcmdoc.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
	SET_SOURCE_FILES_PROPERTIES(${CMAKE_CURRENT_SOURCE_DIR}/PkgInfo PROPERTIES MACOSX_PACKAGE_LOCATION .)

	SET(APPBUNDLE ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.app)
	SET(MACOSX_BUNDLE_GUI_IDENTIFIER "com.metaemotion.Ginkgo_CADx")
	SET(MACOSX_BUNDLE_BUNDLE_NAME ${PROJECT_NAME})
	SET(MACOSX_BUNDLE_VERSION ${GINKGO_VERSION})
	
	CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/Ginkgo-Info.plist.in ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
	
	SET(LIBS)

	MESSAGE("PLUGINS = ${GINKGO_PLUGINS}")
	FOREACH(PLUGIN ${GINKGO_PLUGINS})
		LIST(APPEND LIBS ${CMAKE_CURRENT_BINARY_DIR}/../${PLUGIN}/lib${PLUGIN}.dylib)
	ENDFOREACH()

	install(CODE 
	        " 
	        include(BundleUtilities) 
	        fixup_bundle(\"${APPBUNDLE}\" \"${LIBS}\" \"${DIRS}\") 
	        " 
	        COMPONENT Runtime 
	    )
		
	SET_TARGET_PROPERTIES(
		"${PROJECT_NAME}"
		PROPERTIES
			MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_BINARY_DIR}/Info.plist
		    LINK_FLAGS "-Wl ${XCODE_LINK_FLAGS}"
	)
ENDIF()

MESSAGE("OS=[${OS}], Arch=[${ARCH}], Target=[${CMAKE_BUILD_TYPE}], Project=[${PROJECT_NAME}]")

=== src/visualizator/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

PROJECT(visualizator)

################ SOURCES ################

SET(SRCS visualizator.cpp)
AUX_SOURCE_DIRECTORY(visualizator/comandos SRCS)
AUX_SOURCE_DIRECTORY(visualizator/controllers SRCS)
AUX_SOURCE_DIRECTORY(visualizator/dialogos SRCS)
AUX_SOURCE_DIRECTORY(visualizator/dialogos/importacion SRCS)
AUX_SOURCE_DIRECTORY(visualizator/dialogos/seleccionardiagnostico SRCS)
AUX_SOURCE_DIRECTORY(visualizator/estudios SRCS)
AUX_SOURCE_DIRECTORY(visualizator/herramientas SRCS)
AUX_SOURCE_DIRECTORY(visualizator/vistas SRCS)
AUX_SOURCE_DIRECTORY(visualizator/widgets SRCS)
AUX_SOURCE_DIRECTORY(visualizator/wxvtk SRCS)
AUX_SOURCE_DIRECTORY(visualizator/wxvtk/reconstruction SRCS)
AUX_SOURCE_DIRECTORY(visualizator/wxvtk/reconstruction/commands SRCS)
AUX_SOURCE_DIRECTORY(visualizator/wxvtk/reconstruction/interactors SRCS)
AUX_SOURCE_DIRECTORY(visualizator/wxvtk/reconstruction/pipelines SRCS)
AUX_SOURCE_DIRECTORY(visualizator/wxvtk/reconstruction/volumedataset SRCS)
AUX_SOURCE_DIRECTORY(recursos SRCS)

################ DEFINITIONS ################

ADD_EXTENSION_DEFINITIONS()

################ INCLUDE DIRECTORIES ################

SET(${PROJECT_NAME}_INCLUDE_DIR
	${CMAKE_CURRENT_SOURCE_DIR}
	${CMAKE_CURRENT_SOURCE_DIR}/comandos
	${CMAKE_CURRENT_SOURCE_DIR}/controllers
	${CMAKE_CURRENT_SOURCE_DIR}/dialogos
	${CMAKE_CURRENT_SOURCE_DIR}/estudios
	${CMAKE_CURRENT_SOURCE_DIR}/eventos
	${CMAKE_CURRENT_SOURCE_DIR}/exportacion
	${CMAKE_CURRENT_SOURCE_DIR}/herramientas
	${CMAKE_CURRENT_SOURCE_DIR}/vistas
	${CMAKE_CURRENT_SOURCE_DIR}/widgets
	${CMAKE_CURRENT_SOURCE_DIR}/wxvtk
	CACHE INTERNAL ""
)

INCLUDE_DIRECTORIES(${CADxCore_INCLUDE_DIR})

INCLUDE_DIRECTORIES(${${PROJECT_NAME}_INCLUDE_DIR})

################ TARGET ################

IF(LINUX AND NOT CUSTOM_PACKAGE)
	SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
	SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 
	SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/share/ginkgocadx/bin")
	SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
	LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/share/ginkgocadx/bin" isSystemDir)
	IF("${isSystemDir}" STREQUAL "-1")
		SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/share/ginkgocadx/bin")
	ENDIF()
ENDIF()

ADD_LIBRARY(${PROJECT_NAME} SHARED ${SRCS} )
#ADD_EXECUTABLE(${PROJECT_NAME} WIN32 MACOSX_BUNDLE ${SRCS})
SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES
	VERSION "${GINKGO_VERSION}" SOVERSION "${GINKGO_VERSION}"
	LINK_INTERFACE_LIBRARIES ""
	INSTALL_RPATH_USE_LINK_PATH TRUE )
INSTALL(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION share/ginkgocadx/bin/Plugins)
INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/lang/es/visualizator.mo DESTINATION share/ginkgocadx/bin/lang/es)
INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/lang/ja/visualizator.mo DESTINATION share/ginkgocadx/bin/lang/ja)

################ LIBS ################

TARGET_LINK_LIBRARIES(${PROJECT_NAME} CADxCore)

IF(USE_CUSTOM_WX)
	ADD_DEFINITIONS(${wxWidgets_defines})
	INCLUDE_DIRECTORIES(${wxWidgets_INCLUDE_DIR})
	LINK_DIRECTORIES(${wxWidgets_DIR})
ELSE()
	INCLUDE(${wxWidgets_USE_FILE})
	#MESSAGE("WXLIBS = ${wxWidgets_LIBRARIES} ")
ENDIF()

TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${wxWidgets_LIBRARIES})

IF (USE_CUSTOM_VTK)
	ADD_DEFINITIONS(${VTK_defines})
	INCLUDE_DIRECTORIES(${VTK_INCLUDE_DIR})
	LINK_DIRECTORIES(${VTK_DIR})
ELSE()
	INCLUDE(${VTK_USE_FILE})
	SET(VTK_LIBRARIES vtkCommon vtkGraphics vtkFiltering vtkHybrid vtkIO vtkRendering vtkImaging
	vtkGenericFiltering vtkWidgets vtkftgl vtkVolumeRendering vtkexoIIc vtkDICOMParser CACHE INTERNAL "")
	#MESSAGE("VTKLIBS = ${VTK_LIBRARIES}")
ENDIF()

TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${VTK_LIBRARIES})

IF(USE_CUSTOM_ITK)
	ADD_DEFINITIONS(${ITK_defines})
	INCLUDE_DIRECTORIES(${ITK_INCLUDE_DIR})
	LINK_DIRECTORIES(${ITK_DIR})
ELSE()
	INCLUDE(${ITK_USE_FILE})
	#MESSAGE("ITKLIBS = ${ITK_LIBRARIES}")
ENDIF()

TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${ITK_LIBRARIES})

ADD_DEFINITIONS(${Cairo_defines})
INCLUDE_DIRECTORIES(${Cairo_INCLUDE_DIR})
LINK_DIRECTORIES(${Cairo_LIB})
TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${Cairo_LIBRARIES})

ADD_DEFINITIONS(${Pixman_defines})
INCLUDE_DIRECTORIES(${Pixman_INCLUDE_DIR})
LINK_DIRECTORIES(${Pixman_LIB})
TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${Pixman_LIBRARIES})

IF (LINUX)
	TARGET_LINK_LIBRARIES(${PROJECT_NAME} GL xml2)
ENDIF()

IF(MACOS)
	FIND_LIBRARY( CARBON_LIB Carbon )
	FIND_LIBRARY( OPENGL_LIB OpenGL )
	
	MARK_AS_ADVANCED( CARBON_LIB OPENGL_LIB )

	SET(LIBS ${CARBON_LIB} ${OPENGL_LIB} )
	LIST( APPEND LIBS xml2 z )

	TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${LIBS})

	SET_TARGET_PROPERTIES( PROPERTIES LINK_FLAGS "-Wl ${XCODE_LINK_FLAGS}" )
	
ENDIF()

MESSAGE("OS=[${OS}], Arch=[${ARCH}], Target=[${CMAKE_BUILD_TYPE}], Project=[${PROJECT_NAME}]")

=== src/visualizator/Makefile ===
#
#  There exist several targets which are by default empty and which can be 
#  used for execution of your targets. These targets are usually executed 
#  before and after some main targets. They are: 
#
#     .build-pre:              called before 'build' target
#     .build-post:             called after 'build' target
#     .clean-pre:              called before 'clean' target
#     .clean-post:             called after 'clean' target
#     .clobber-pre:            called before 'clobber' target
#     .clobber-post:           called after 'clobber' target
#     .all-pre:                called before 'all' target
#     .all-post:               called after 'all' target
#     .help-pre:                called before 'help' target
#     .help-post:               called after 'help' target
#
#  Targets beginning with '.' are not intended to be called on their own.
#
#  Main targets can be executed directly, and they are:
#  
#     build                    build a specific configuration
#     clean                    remove built files from a configuration
#     clobber                  remove all built files
#     all                      build all configurations
#     help                     print help mesage
#  
#  Targets .build-impl, .clean-impl, .clobber-impl, .all-impl, and
#  .help-impl are implemented in nbproject/makefile-impl.mk.
#
# NOCDDL


# Environment 
MKDIR=mkdir
CP=cp
CCADMIN=CCadmin
RANLIB=ranlib


# build
build: .build-post

.build-pre:
# Add your pre 'build' code here...

.build-post: .build-impl
# Add your post 'build' code here...


# clean
clean: .clean-post

.clean-pre:
# Add your pre 'clean' code here...

.clean-post: .clean-impl
# Add your post 'clean' code here...


# clobber
clobber: .clobber-post

.clobber-pre:
# Add your pre 'clobber' code here...

.clobber-post: .clobber-impl
# Add your post 'clobber' code here...


# all
all: .all-post

.all-pre:
# Add your pre 'all' code here...

.all-post: .all-impl
# Add your post 'all' code here...


# help
help: .help-post

.help-pre:
# Add your pre 'help' code here...

.help-post: .help-impl
# Add your post 'help' code here...



# include project implementation makefile
include nbproject/Makefile-impl.mk

=== debian/changelog ===
ginkgocadx (2.4.1.1-2) unstable; urgency=low

  * debian/patches/01_no_msse.patch: Do not build with -msse flag
    Closes: #630852

 -- Andreas Tille <tille@debian.org>  Sat, 18 Jun 2011 08:10:00 +0200

ginkgocadx (2.4.1.1-1) unstable; urgency=low

  * Initial release (Closes: #628106)

 -- Andreas Tille <tille@debian.org>  Mon, 02 May 2011 08:09:26 +0200

=== debian/control ===
Source: ginkgocadx
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>, Thorsten Alteholz <debian@alteholz.de>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 8), cmake (>= 2.8), libgtk2.0-dev, libxml2-dev, libssl-dev, libwrap0-dev,
 libwxgtk2.8-dev (>= 2.8.10), libvtk5-dev (>= 5.6.0), libinsighttoolkit3-dev (>= 3.20.0),
 libdcmtk2-dev (>= 3.6.0), libcairo2-dev (>= 1.8.10), 
 libgdcm2-dev, libwrap0, libfftw3-dev, chrpath, libsqlite3-dev,
 libmysqlclient16 (>= 5.1.57)
Standards-Version: 3.9.2
Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/ginkgocadx/trunk/?rev=0&sc=0
Vcs-Svn: svn://svn.debian.org/svn/debian-med/trunk/packages/ginkgocadx/trunk/
Homepage: http://ginkgo-cadx.com/

Package: ginkgocadx
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Medical Imaging Software and complete DICOM Viewer
 Ginkgo CADx provides a complete DICOM viewer solution with advanced
 capabilities and support for extensions.
 .
  * Easy and customizable interface through profiles.
  * Full featured DICOM image visualization.
  * Complete tool set (measure, markers, text, ...).
  * Multiple modalities support (Neurological, Radiological, Dermatological,
    Ophthalmological, Ultrasound, Endoscopy, ...)
  * Dicomization support from JPEG, PNG, GIF and TIFF.
  * Full EMH integration support: HL7 standard and IHE compliant workflows.
  * PACS Workstation (C-FIND, C-MOVE, C-STORE...)
  * Extensible through custom extensions.
    - Retinal image mosaic composition.
    - Automatic retinal analysis diagnostics.
    - Psoriasis automatic diagnostics.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# debian/rules for Ginkgo CADx

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --buildsystem=cmake --parallel

VER_FULL = $(shell dpkg-parsechangelog | grep '^Version' | cut -d' ' -f2 | cut -f1 -d-)

UPSTREAM_SRC = ginkgocadx-$(VER_FULL)
DEBIAN_SRC_DIR = ginkgocadx-$(VER_FULL)
DEBIAN_SRC_TAR = ginkgocadx_$(VER_FULL).orig.tar.gz

$(UPSTREAM_SRC).tgz:
	wget -c http://voxel.dl.sourceforge.net/sourceforge/ginkgocadx/$@

get-orig-source: $(UPSTREAM_SRC).tgz
	tar xzf $(UPSTREAM_SRC).tgz
	# strip debian subdir
	rm -rf $(UPSTREAM_SRC)/debian
	GZIP="--best --no-name" tar czf $(DEBIAN_SRC_TAR) $(DEBIAN_SRC_DIR)

override_dh_auto_install:
	dh_auto_install
	dh_installchangelogs debian/changelog
	# there are two path in rpath, one to libraries for the package and one
	# for mpi, the later has to be removed
	[ ! -f debian/ginkgocadx/usr/lib/ginkgocadx/Plugins/libvisualizator.so.$(VER_FULL) ] ||  /usr/bin/chrpath -r /usr/lib/ginkgocadx debian/ginkgocadx/usr/lib/ginkgocadx/Plugins/libvisualizator.so.$(VER_FULL)
	[ ! -f debian/ginkgocadx/usr/lib/ginkgocadx/libCADxCore.so.$(VER_FULL) ] || /usr/bin/chrpath -r /usr/lib/ginkgocadx debian/ginkgocadx/usr/lib/ginkgocadx/libCADxCore.so.$(VER_FULL)

=== debian/watch ===
version=3
http://sf.net/ginkgocadx/ginkgocadx-(.*)\.tgz

# http://sf.net/ginkgocadx/Ginkgo_CADx-(.*)_src\.tgz
